/*

̃vOɂ

ARToolKitGLMetaseqgāC}[J̏Ƀ^ZRCA3Df
\TvvOłD

gPrefWindowed̒lTRUEɂ΃EBhE[hC
FALSEɂ΃tXN[[hɂȂ܂D


OtBbNX̏nɂ

̃vO̓OtBbNX̏n gsub_lite gpĂ܂igsubł͂ȂjD

gsub      ... arg֐Qigsub.hj
gsub_lite ... argl֐Qigsub_lite.hj

gsubɂGLUTɂEBhECR[obNǗ܂܂Ă܂C
gsub_liteɂ͊܂܂܂DȂ킿Cgsub_litegč\zꍇC
EBhE̋Ɋւ镔GLUTŔ͂őgނƂɂȂ܂C
gsubƂ͈āuŉĂ̂悭킩Ȃv
ȂC낢DsƎv܂iOpenGL/GLUTo҂́jD

gsubgsub_litëႢɂĂ͂QƂĂ
http://www.hitl.washington.edu/artoolkit/documentation/devframework.htm


GLMetaseqgꍇ

GLMetaseqƈꏏɎgꍇ́C̃TvvÔ悤ɁCgsub_lite
gƂ߂܂Dgsub̏ꍇCgsub́uŉĂ̂
悭킩Ȃv̉e3Df̃eNX`̏܂Ȃ
Ƃ܂DbC̃vOx[XɂĂƂ
łˁD


Copyright (c) Sunao Hashimoto

*/


// ============================================================================
//	CN[h
// ============================================================================

#ifdef _WIN32
#include <windows.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#ifndef __APPLE__
#include <GL/gl.h>
#include <GL/glut.h>
#else
#include <OpenGL/gl.h>
#include <GLUT/glut.h>
#endif

#include <AR/config.h>
#include <AR/video.h>
#include <AR/param.h>
#include <AR/ar.h>
#include <AR/gsub_lite.h>

#include "GLMetaseq.h"


// ============================================================================
//	Cu
// ============================================================================

#ifdef _DEBUG
	#pragma comment(lib,"libARd.lib")
	#pragma comment(lib,"libARgsubd.lib")
	#pragma comment(lib,"libARvideod.lib")
	#pragma comment(lib,"libARgsub_lited.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmtd.lib")
#else
	#pragma comment(lib,"libAR.lib")
	#pragma comment(lib,"libARgsub.lib")
	#pragma comment(lib,"libARvideo.lib")
	#pragma comment(lib,"libARgsub_lite.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")
#endif


// ============================================================================
//	O[oϐ
// ============================================================================

// TRUEFEBhE[h^FALSEFtXN[[h
static const int gWindowed = TRUE;

// tXN[[h̐ݒ
static const int gFullWidth    = 800;	// ʉ𑜓x
static const int gFullHeight   = 600;	// ʉ𑜓x
static const int gFullDepth    = 32;	// rbg
static const int gFullRefresh  = 0;		// tbV[gD0ŃftHglD

// E^zẼXP[t@N^
static const double gViewScaleFactor = 1.0;

// E͈̔́iMin`Max܂ł͈̔͂ɂIuWFNg`j
static const double gViewDistanceMin = 0.1;
static const double gViewDistanceMax = 1000.0; 

static char *gCparamName = "Data/camera_para.dat";		// Jp[^t@C
static char *gVconf      = "Data/WDM_camera_flipV.xml";	// rfIfoCX̐ݒt@C
static char *gPattName   = "Data/patt.hiro";			// p^[t@C
static char *gModelName  = "Data/ninja.mqo";			// ft@C

static ARUint8		*gARTImage     = NULL;		// J摜ւ̃|C^
static int			gARTThreshhold = 100;		// 2l臒l
static MQO_MODEL	gModel = NULL;				// 3Df

static double	gPatt_width     = 80.0;			// p^[̃TCYimmPʁj
static double	gPatt_centre[2] = {0.0, 0.0};	// p^[̒SʒuimmPʁj
static double	gPatt_trans[3][4];				// Wϊs
static int		gPatt_found = FALSE;			// p^[otO
static int		gPatt_id;						// p^[ID

static ARParam						gARTCparam;				// Jp[^
static ARGL_CONTEXT_SETTINGS_REF	gArglSettings = NULL;	// `n̐ݒ



// ============================================================================
// J̃ZbgAbv֐
// ============================================================================
static int SetupCamera( const char *cparam_name, char *vconf, ARParam *cparam )
{	
    ARParam		wparam;			// Jp[^iƗpϐj
	int			xsize, ysize;	// 摜TCY

	// rfIfoCXJ
    if ( arVideoOpen( vconf ) < 0 ) {
		printf( "J܂\n" );
		return FALSE;
	}
	
    // 摜̃TCY擾
	if ( arVideoInqSize( &xsize, &ysize ) < 0 ) {
		printf( "摜TCY̎擾Ɏs܂\n" );
		return FALSE;
	}

	// Jp[^̃[hCl̏CƏ
	if ( arParamLoad( cparam_name, 1, &wparam ) < 0 ) {
		printf( "Jp[^t@C̃[hɎs܂\n" );
        return FALSE;
    }
    arParamChangeSize( &wparam, xsize, ysize, cparam );
    arInitCparam( cparam );

	// rfILv`̃X^[g
	if ( arVideoCapStart() != 0 ) {
		printf( "rfILv`̃X^[gɎs܂\n" );
		return FALSE;
	}
	
	return TRUE;
}


// ============================================================================
// }[J̃ZbgAbv֐
// ============================================================================
static int SetupMarker( const char *patt_name, int *patt_id )
{
	// }[J̃[h
    if ( ( *patt_id = arLoadPatt( patt_name ) ) < 0 ) {
		printf( "p^[t@C̃[hɎs܂\n" );
        return FALSE;
    }
	
	return TRUE;
}


// ============================================================================
// `ñZbgAbv֐iEBhEj
// ============================================================================
static int SetupGraphicsWin( const char *title, int dispWidth, int dispHeight )
{
	// fBXvC[h̐ݒ
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

	// EBhE̐ݒ
	glutInitWindowSize( dispWidth, dispHeight );
	glutCreateWindow( title );

	// gsub_lite Cȕ
	if ( ( gArglSettings = arglSetupForCurrentContext() ) == NULL ) {
		return FALSE;
	}

	return TRUE;
}


// ============================================================================
// `ñZbgAbv֐itXN[j
// ============================================================================
static int SetupGraphicsFull( int dispWidth, int dispHeight, int dispDepth, int dispRefresh )
{
	char glutGamemode[32];

	// fBXvC[h̐ݒ
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

	// tXN[̐ݒ
	if ( dispRefresh ) {
		sprintf( glutGamemode, "%ix%i:%i@%i", dispWidth, dispHeight, dispDepth, dispRefresh );
	} else {
		sprintf( glutGamemode, "%ix%i:%i", dispWidth, dispHeight, dispDepth );
	}
	glutGameModeString( glutGamemode );
	glutEnterGameMode();

	// gsub_lite Cȕ
	if ( ( gArglSettings = arglSetupForCurrentContext() ) == NULL ) {
		return FALSE;
	}

	return TRUE;
}


// ============================================================================
// I֐
// ============================================================================
static void Quit( void )
{
	arVideoCapStop();				// rfILv`̒~
	arVideoClose();					// rfIfoCX
	arglCleanup( gArglSettings );	// `n̏I

	mqoDeleteModel( gModel );		// f̍폜
	mqoCleanup();					// GLMetaseq̏I
}


// ============================================================================
// L[Cxg֐
// ============================================================================
static void Keyboard( unsigned char key, int x, int y )
{
	switch ( key ) {
		case 0x1B:	// IR}h
		case 'Q':
		case 'q':
			exit(0);
			break;
		default:
			break;
	}
}


// ============================================================================
// ACh֐
// ============================================================================
static void Idle( void )
{
	static int ms_prev;		// O̎
	int ms;					// ݂̎
	float s_elapsed;		// oߎ
	ARUint8 *image;			// 摜

	ARMarkerInfo	*marker_info;	// }[J
    int				marker_num;		// oꂽ}[J̐
	int				j, k;


	// ǑĂяǒoߎԂvCXV100HzȉɂȂ悤ɂ
	ms = glutGet( GLUT_ELAPSED_TIME );
	s_elapsed = (float)( ms - ms_prev ) * 0.001;
	if ( s_elapsed < 0.01f ) return;
	ms_prev = ms;


	// J摜̎擾
	if ( ( image = arVideoGetImage() ) != NULL ) {

		gARTImage = image;		// 摜ւ̃|C^擾
		gPatt_found = FALSE;	// }[J̌oԂ

		// }[J̌o
		if ( arDetectMarker( gARTImage, gARTThreshhold, &marker_info, &marker_num ) < 0 ) {
			exit(0);
		}

		// łMx̍}[JT
		k = -1;
		for ( j = 0; j < marker_num; j++ ) {
			if ( marker_info[j].id == gPatt_id ) {
				if ( k == -1 ) k = j;
				else if( marker_info[j].cf > marker_info[k].cf ) k = j;
			}
		}
	
		// łvx̍}[J( k )ɑ΂čWϊs߂
		if ( k != -1 ) {
			arGetTransMat( &( marker_info[k] ), gPatt_centre, gPatt_width, gPatt_trans );
			gPatt_found = TRUE;
		}

		// ʂ̕`w
		glutPostRedisplay();
	}

}


// ============================================================================
// EBhẺ`FbN֐
// ============================================================================
static void Visibility( int visible )
{
	// EBhEĂȂƂ̓ACh֐𖳌ɂ
	if ( visible == GLUT_VISIBLE ) {
		glutIdleFunc( Idle );
	} else {
		glutIdleFunc( NULL );
	}
}


// ============================================================================
// EBhETCYύXꂽƂɌĂ΂֐
// ============================================================================
static void Reshape( int w, int h )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glViewport( 0, 0, (GLsizei) w, (GLsizei) h );
	
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
}


// ============================================================================
// ݒ肷֐
// ============================================================================
static void SetLight( GLenum light )
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( light, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( light, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( light, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( light, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glEnable( light );	// ̗L
}


// ============================================================================
// fBXvC֐
// ============================================================================
static void Display( void )
{
    GLdouble p[16];	// ˉeϊs
	GLdouble m[16];	// Wϊs
	

	glDrawBuffer( GL_BACK );								// obNobt@ɕ`
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	// obt@̏
	
	// J摜̕`
	arglDispImage( gARTImage, &gARTCparam, 1.0, gArglSettings );	// zoom = 1.0.

	// t[̃Lv`w
	arVideoCapNext();
	gARTImage = NULL;


	// }[JĂ
	if ( gPatt_found ) {

		// ˉeϊs̓Kp
		arglCameraFrustumRH( &gARTCparam, gViewDistanceMin, gViewDistanceMax, p );
		glMatrixMode( GL_PROJECTION );
		glLoadMatrixd( p );

		// fr[s̏
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();

		glClear( GL_DEPTH_BUFFER_BIT );			// Zobt@̏
		glEnable( GL_DEPTH_TEST );				// Bʏ̓Kp

		// ̐ݒi_ɑ΂ČŒj
		glPushMatrix();
			SetLight( GL_LIGHT0 );
		glPopMatrix();

		// Wϊs̓Kp
		arglCameraViewRH( gPatt_trans, m, gViewScaleFactor );
		glLoadMatrixd( m );

		// 3DIuWFNg̕`
		glEnable( GL_LIGHTING );				// ON

		glPushMatrix();
			glRotatef( 90.0, 1.0, 0.0, 0.0 );	// f𗧂
			mqoCallModel( gModel );				// f̕`
		glPopMatrix();

		glDisable( GL_LIGHTING );				// OFF
		glDisable( GL_DEPTH_TEST );

	}

	glutSwapBuffers();	// obt@̔]
}


// ============================================================================
// main֐
// ============================================================================
int main( int argc, char** argv )
{
	// GLUT̏
	glutInit( &argc, argv );

	// J̃ZbgAbv
	if ( !SetupCamera( gCparamName, gVconf, &gARTCparam ) ) return 0;

	// }[J̃ZbgAbv
	if ( !SetupMarker( gPattName, &gPatt_id ) ) return 0;

	// `ñZbgAbv
	if ( gWindowed ) {
		if ( !SetupGraphicsWin( "MQO Loader on ARToolKit - gsub_lite edition", arImXsize, arImYsize ) ) return 0;
	} else {
		if ( !SetupGraphicsFull( gFullWidth, gFullHeight, gFullDepth, gFullRefresh ) ) return 0;
	}

	// GLMetaseq̏
	mqoInit();

	// f̓ǂݍ
	if ( ( gModel = mqoCreateModel( gModelName, 1.0 ) ) == NULL ) {
		printf( "f̓ǂݍ݂Ɏs܂" );
		return 0;
	}

	// IɌĂ΂֐̐ݒ
	atexit( Quit );

	// R[obN֐̐ݒ
	glutDisplayFunc( Display );
	glutReshapeFunc( Reshape );
	glutVisibilityFunc( Visibility );
	glutKeyboardFunc( Keyboard );
	
	glutMainLoop();

	return 0;
}
